int MAXX=700;
int MAXY=210;

final color ZWART  = color(50,50,55);
final color ROOD   = color(200,70,50);
final color GROEN  = color(70,180,70);

class BPart {
      int xRel;
      int yRel;
      int w, h;
      color clr;
      BPart(){
      }
      void drw(int xAbs, int yAbs){
           fill(clr);
           noStroke();
           rect((xAbs + xRel),(height-(yAbs + yRel)),w,-h); 
      }
}

class Foot extends BPart {
      Foot(int x, int y) { 
            xRel = x;
            yRel = y;
            w = 14 + int(random(6));
            h = 5 + int(random(2));
            clr = ZWART;
      }
      void vertical(){
            int tmp=w; w=h; h=tmp;
            xRel-=w;
            yRel-=h;
      }
}

class Leg extends BPart {
      Leg(int x, int y) { 
            xRel = x;
            yRel = y;
            w = 7 + int(random(2));
            h = 25 + int(random(5));
            clr = ROOD;
      }
      void horizontal(){
            int tmp=w; w=h; h=tmp;
            xRel-=w;
            yRel= w;
      }
}

class Torso extends BPart {
      Torso(int x, int y) { 
            xRel = x;
            yRel = y;
            w = 15 + int(random(5));
            h = 30 + int(random(10));
            clr = GROEN;
      }
}

class Head extends BPart {
      Head(int xr, int yr) { 
            xRel = xr;
            yRel = yr;
            w = 16 + int(random(3));
            h = 9 + int(random(12));
            clr = ZWART;
      }
}

class Hands extends BPart {
      Hands(int xr, int yr) { 
            xRel = xr;
            yRel = yr;
            w = 8 + int(random(2));
            h = 8 + int(random(5));
            clr = ROOD;
      }
}


class Skater {
  int x; /*xy of basis*/
  int y; /*y counts up*/
  Foot foot;
  Leg  leg;
  Torso torso;
  Head head;
  Leg hleg;
  Foot hfoot;
  Hands hands;
  Skater(int xb, int yb) {
        x = xb;
        y = yb;
        foot = new Foot(0,0);
        leg = new Leg(0, 5 + foot.h);
        torso = new Torso(0, 10 + foot.h + leg.h); 
        head  = new Head(2+torso.w, 15 + foot.h + leg.h + torso.h);
        hleg  = new Leg(-5, 5 + foot.h); 
                hleg.h/=2; 
                hleg.horizontal(); 
                hleg.yRel = 5+foot.h+leg.h -hleg.h;
        hfoot = new Foot(hleg.xRel-5,hleg.yRel+hleg.h);
                hfoot.vertical();
        hands = new Hands(-5,torso.yRel);
                hands.xRel-=hands.w;
  } 
  void age(){
   if (random(1)<.2) head.yRel--;
  }
  void drw(){
    if (head.yRel+head.h>torso.yRel+torso.h){
       foot.drw(x,y);
       leg.drw(x,y); 
       torso.drw(x,y);
       head.drw(x,y);
       hleg.drw(x,y);
       hfoot.drw(x,y);
       hands.drw(x,y);
    }
  }
}
 

int NRSKATERS=10;
Skater[] skaters = new Skater[NRSKATERS];

void setup(){
     size(MAXX,MAXY);
     background(250);
     int d=MAXX/(NRSKATERS+1);
     int x=d;
     int y=50;
     for (int i=0; i<NRSKATERS; i++){
         skaters[i] = new Skater(x,y);
         x = x+d;
     }
}

void draw(){
     fill(255); rect(0,0,MAXX,MAXY);
     for (int i=0; i<NRSKATERS; i++) skaters[i].drw();
     skaters[2].age();
     delay(100);
}
